package Game 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.TiledImage;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class GUI extends Entity 
	{
		private var hearts:TiledImage;
		private var heartsTop:TiledImage;
		private var keyIcon:Image = new Image(Assets.Key);
		private var keyText:Text = new Text("0");
		private var keyTextBG:Text = new Text("0");
		
		public function GUI() 
		{
			layer = GC.LAYER_GUI;
			
			keyIcon.scrollX = 0;
			keyIcon.scrollY = 0;
			keyIcon.y = 24 + 30;
			keyIcon.x = 10;
			
			keyTextBG.color = 0x000000;
			keyTextBG.size = 24;
			keyTextBG.x = 40;
			keyTextBG.y = 24 + 32;
			keyTextBG.scrollX = 0;
			keyTextBG.scrollY = 0;
			keyTextBG.text = GV.keys.toString();
			
			keyText.color = 0xFFFFFF;
			keyText.size = 24;
			keyText.x = 38;
			keyText.y = 24 + 30;
			keyText.scrollX = 0;
			keyText.scrollY = 0;
			keyText.text = GV.keys.toString();
			
		}
		
		
		
		public function updateKeys():void
		{
			keyText.text = GV.keys.toString();
			keyTextBG.text = GV.keys.toString();
		}
		
		public function updateHealth():void
		{
			
			GV.hero.maxhealth = GV.maxhealth;
			GV.health = GV.hero.health;
			
			var sizeX:int = 16 * GV.hero.health;
			if (sizeX < 0) sizeX = 1;
			hearts = new TiledImage(Assets.Heart, sizeX, 16);
			hearts.x = 16;
			hearts.y = 24;
			hearts.scrollX = 0;
			hearts.scrollY = 0;
			heartsTop = new TiledImage(Assets.HeartContainer, 16 * GV.hero.maxhealth, 16);
			heartsTop.x = 16;
			heartsTop.y = 24;
			heartsTop.scrollX = 0;
			heartsTop.scrollY = 0;
			
			
			
			
			graphic = new Graphiclist(hearts, heartsTop, keyIcon, keyTextBG, keyText);	
			
		}
		
		
		
		
	}

}