package Game 
{
	import Game.Items.Boy;
	import Game.Items.HeartContainer;
	import Game.Items.Key;
	import Game.Items.LockedDoor;
	import Game.Items.Necklace;
	import Game.Items.Princess;
	import Game.Items.Spikes;
	import Game.Items.Tree;
	import Game.Mobs.Guard;
	import Game.Mobs.King;
	import Game.Mobs.Skeleton;
	import Game.Mobs.Slime;
	import Game.Mobs.Wizard;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Tilemap;
	import net.flashpunk.masks.Grid;
	import net.flashpunk.World;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class GameWorld extends World 
	{
		
		
		
		public function GameWorld() 
		{
			
		}
		
		override public function begin():void
		{
			super.begin();
			
			// loading the world
			
			GV.bottomEmitter = new ParticleController();
			GV.bottomEmitter.layer = GC.LAYER_PARTICLE_BOTTOM;
			add(GV.bottomEmitter);
			
			GV.gui = new GUI;
			add(GV.gui);
			
			if (GV.levelXML == null) LevelList.loadLevel(0);
			
			var xml:XML = GV.levelXML; 
			
			GV.layer1 = new Tilemap(Assets.FLOOR_TILES, xml.@width, xml.@height, 32, 32);
			GV.layer1.loadFromString(xml.layer1);
			
			GV.layer2 = new Tilemap(Assets.LAYER_2, xml.@width, xml.@height, 32, 32);
			GV.layer2.loadFromString(xml.layer2);
			
			GV.layer3 = new Tilemap(Assets.LAYER_3, xml.@width, xml.@height, 32, 32);
			GV.layer3.loadFromString(xml.layer3);
			
			GV.grid = new Grid(xml.@width, xml.@height, 32, 32);
			GV.grid.loadFromString(xml.grid, "");
			
			
			var e:Entity = new Entity(0, 0, new Graphiclist(GV.layer1, GV.layer2));
			e.layer = GC.LAYER_FLOORS;
			e.mask = GV.grid;
			e.type = "solid";
			add(e);
			
			
			// load entities
			var list:XMLList; // holds an xmllist
			var element:XML; // a specific xml element
			
			list = xml.entities.Enemy;
			for each (element in list) {
				add(new Slime(element.@x, element.@y));
			}
			
			list = xml.entities.Skeleton;
			for each (element in list) {
				add(new Skeleton(element.@x, element.@y));
			}
			
			list = xml.entities.Boy;
			for each (element in list) {
				add(new Boy(element.@x, element.@y));
			}
			
			list = xml.entities.Knight;
			for each (element in list) {
				add(new Guard(element.@x, element.@y));
			}
			
			list = xml.entities.King;
			for each (element in list) {
				add(new King(element.@x, element.@y));
			}
			
			list = xml.entities.Archer;
			for each (element in list) {
				add(new Necklace(element.@x, element.@y));
			}
			
			list = xml.entities.tree;
			for each (element in list) {
				add(new Tree(element.@x, element.@y));
			}
			
			list = xml.entities.Magician;
			for each (element in list) {
				add(new Wizard(element.@x, element.@y));
			}
			
			
			list = xml.entities.TextTrigger;
			for each (element in list) {
				add(new TextTrigger(element.@x, element.@y, element.@width, element.@height,element.@text, element.@textid));
			}
			
			
			
			list = xml.entities.TeleportTrigger;
			for each (element in list) {
				add(new TeleporterTrigger(element.@x, element.@y, element.@width, element.@height, element.@level, element.@tpx, element.@tpy));
			}
			
			list = xml.entities.Key;
			for each (element in list) {
				add(new Key(element.@x, element.@y, element.@keyid));
			}
			
			list = xml.entities.HeartContainer;
			for each (element in list) {
				add(new HeartContainer(element.@x, element.@y, element.@heartid));
			}
			
			list = xml.entities.spikes;
			for each (element in list) {
				add(new Spikes(element.@x, element.@y));
			}
			
			list = xml.entities.Princess;
			for each (element in list) {
				add(new Princess(element.@x, element.@y, element.@princessid));
			}
			
			
			HeartContainer
			
			list = xml.entities.Door;
			for each (element in list) {
				add(new LockedDoor(element.@x, element.@y, element.@doorid));
			}
			
			e = new Entity(0, 0, GV.layer3);
			e.layer = GC.LAYER_WALLS;
			add(e);
			
			GV.hero = new Player;
			if (GV.health <= 0) GV.health = 5;
			GV.hero.health = GV.health;
			GV.hero.maxhealth = GV.maxhealth;
			
			add(GV.hero);
			GV.hero.x = GV.spawnX;
			GV.hero.y = GV.spawnY;
			
		}
		
	}

}