package Game.Items 
{
	import Game.GameObject;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Sfx;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class LockedDoor extends GameObject 
	{
		
		private static var openDoorSfx:Sfx = new Sfx(Assets.OpenDoor);
			
		private var id:String;
		
		public function LockedDoor(_x:Number = 0, _y:Number = 0, ID:String = "door") 
		{
			
			
			id = ID;
			
			x = _x;
			y = _y - 32;
			
			type = "solid";
			
			graphic = new Image(Assets.LockedDoor);
			setHitbox(64, 92);
			
			
			if (id == "dungeon2" && GV.gottenReward) {
				visible = false;
			}
			
		}
		
		override public function added():void
		{
			super.added();
			
			if (GV.doorIDs[id + "a"] == 1) {
				FP.world.remove(this);
			}
			
			if (id == "dungeon2" && GV.gottenReward) {
				FP.world.remove(this);
			}
		}
		
		override public function update():void
		{
			
			if (id == "dungeon2") return;
			
			
			if (collideWith(GV.hero, x, y + 3)) {
				if (GV.keys > 0) {
					openDoorSfx.play();
					GV.keys--;
					GV.gui.updateKeys();
					FP.world.remove(this);
					GV.doorIDs[id + "a"] = 1;
				}
			}
		}
		
	}

}