package Game.Items 
{
	import Game.GameObject;
	import Game.GameWorld;
	import Game.TextWindow;
	import Menus.GameOver;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class Princess extends GameObject 
	{
		
		private var id:int;
		
		public function Princess(_x:Number = 0, _y:Number = 0, _id:int = 1) 
		{
			
			id = _id;
			
			x = _x;
			y = _y;
			
			var img:Image = new Image(Assets.Princess);
			img.centerOO();
			graphic = img;
			img.y = -32;
			setHitbox(32, 20, 16, 20);
			
			type = "solid";
			
			
		}
		
		override public function added():void
		{
			super.added();
			if ((id == 1 && GV.returnedPrincess == true) || (id == 2 && GV.gottenReward) || (id == 2 && GV.turnedevil)) {
				FP.world.remove(this);
			}
		}
		
		override public function update():void
		{
			
			var heroDist:Number = FP.distance(x, y, GV.hero.x, GV.hero.y);
			var m:TextWindow;
			
			if (heroDist < 150 && id == 2) {
				if (GV.gottenReward && !GV.gamePaused) {
					GV.spawnX = 200;
					GV.spawnY = 200;
					LevelList.loadLevel(5);
					FP.world = new GameWorld();
				}
				
				if ( !GV.gottenReward) {
					
					m = new TextWindow('Princess "Congratulations hero!\n\nYou must be tired, you should return home! \n\nPerhaps someday we shall meet again!"');
					FP.world.add(m);
					GV.gottenReward = true;
					
					Kong.kongregate.stats.submit("RescuedPrincess",1);
					GV.gamePaused = true;
				}
			}
			
			if (heroDist < 150 && id == 3) {
				
				if (GV.turnedevil && !GV.gamePaused) {
					GV.spawnX = 200;
					GV.spawnY = 200;
					LevelList.loadLevel(8);
					FP.world = new GameWorld();
				}
				
				if ( !GV.turnedevil) {
					
					m = new TextWindow('Princess "Thank you for the necklace.\n\nBut you are starting to creep me out.\n\nIf you are seen near the castle again\n\nthe guards have been ordered to stop you"');
					FP.world.add(m);
					GV.turnedevil = true;
					GV.gamePaused = true;
				}
			}
			
			if (heroDist < 50 && id == 4) {
				if (GV.gameOver && !GV.gamePaused) {
					
					FP.world = new GameOver();
				}
				
				if ( !GV.gameOver) {
					
					m = new TextWindow('Princess "Aaaiiiiiiieeee!!!\n\nWhat have you done?\n\nWhat are you going to do with me?!"');
					FP.world.add(m);
					GV.gameOver = true;
					GV.gamePaused = true;
				}
			}
			
			if (heroDist < 50 && GV.killedWizard) {
				
				if (id == 1 && GV.returnedPrincess && !GV.gamePaused) {
					GV.spawnX = 326;
					GV.spawnY = 732;
					LevelList.loadLevel(4);
					FP.world = new GameWorld();
				}
				
				if (id == 1 && !GV.returnedPrincess) {
					
					m = new TextWindow("Thank you for saving me hero!\n\nLet's go see my father, I'm sure he \n\nwill reward you for your deeds!");
					FP.world.add(m);
					GV.returnedPrincess = true;
					GV.gamePaused = true;
				}
				
				
			}
		}
		
	}

}