package Game.Mobs 
{
	import Game.Actor;
	import Game.ActorState;
	import Game.GameWorld;
	import Game.Items.Heart;
	import Game.TextWindow;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class Guard extends Actor 
	{
		
			public function Guard(_x:Number = 0, _y:Number = 0)
			{
			
			speed = 120;
			health = 5;
			x = _x;
			y = _y;
			
			sprites = new Spritemap(Assets.Guard, 64, 64);
			sprites.add("walkDown", [0, 4, 0, 8], 8, true);
			sprites.add("walkUp", [1, 5, 1, 9], 8, true);
			sprites.add("walkLeft", [2, 6, 2, 10], 8, true);
			sprites.add("walkRight", [3, 7, 3, 11], 8, true);
			
			sprites.add("standDown", [0]);
			sprites.add("standUp", [1]);
			sprites.add("standLeft", [2]);
			sprites.add("standRight", [3]);
			
			sprites.add("attackDown", [12, 16, 20], 6, false);
			sprites.add("attackUp", [13, 17, 21], 6, false);
			sprites.add("attackLeft", [14, 18, 22], 6, false);
			sprites.add("attackRight", [15, 19, 23], 6, false);
			
			sprites.centerOO();
			sprites.y = -32;
			
			graphic = sprites;
			type = "solid";
			setHitbox(20, 10, 10, 10);
		}
		
		override public function kill():void
		{
			super.kill();
			if (FP.rand(10) > 6) {
				var h:Heart = new Heart();
				h.x = x;
				h.y = y;
				FP.world.add(h);
			}
		}
		
		override public function update():void
		{
			
			if (GV.gamePaused) return;
			
			var heroDist:Number = FP.distance(x, y, GV.hero.x, GV.hero.y);
			
			if (GV.turnedevil == false) {
				invincableTimer = 10;
				
				var m:TextWindow;
				
				if (heroDist < 100 && GV.gottenNecklace) {
					if (GV.guardTP && !GV.gamePaused && !GV.guardTP2) {
						GV.spawnX = 300;
						GV.spawnY = 700;
						LevelList.loadLevel(7);
						FP.world = new GameWorld();
						GV.guardTP2 = true;
					}
					
					if (!GV.guardTP) {
						
						m = new TextWindow('You show the guard the necklace and he\n\nsays he will show you to the throne room.');
						FP.world.add(m);
						GV.guardTP = true;
						GV.gamePaused = true;
					}
				}
				
				return;
			}
			
			movement.x = 0;
			movement.y = 0;
			
			if (state == ActorState.IDLE) {
				
				if (heroDist < 200) {
					if (GV.hero.x < x - 15) movement.x = -1;
					if (GV.hero.x > x + 15) movement.x = 1;
					if (GV.hero.y < y - 15) movement.y = -1;
					if (GV.hero.y > y + 15) movement.y = 1;
				}
				
				if (heroDist < 32) {
					GV.hero.hit(this, 2, 1.5);
					state = ActorState.ATTACKING;
					attackTimer = 0.5;
					attackDelay = 0.8;
				}
			}
			
			super.update();
		}
		
		
	}

}