package Game.Mobs 
{
	import Game.Actor;
	import Game.ActorState;
	import Game.Items.Key;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class King extends Actor 
	{
		
		
		
		public function King(_x:Number = 0, _y:Number = 0)
		{
			
			speed = 50;
			health = 1;
			x = _x;
			y = _y;
			
			sprites = new Spritemap(Assets.King, 64, 64);
			sprites.add("walkDown", [0], 8, true);
			sprites.add("walkUp", [0], 8, true);
			sprites.add("walkLeft", [0], 8, true);
			sprites.add("walkRight", [0], 8, true);
			
			sprites.add("standDown", [0], 8, true);
			sprites.add("standUp", [0], 8, true);
			sprites.add("standLeft", [0], 8, true);
			sprites.add("standRight", [0], 8, true);
			
			sprites.add("attackDown", [0], 8, true);
			sprites.add("attackUp", [0], 8, true);
			sprites.add("attackLeft", [0], 8, true);
			sprites.add("attackRight", [0], 8, true);
			
			sprites.centerOO();
			sprites.y = -32;
			
			graphic = sprites;
			type = "solid";
			setHitbox(20, 10, 10, 10);
		}
		
		override public function kill():void
		{
			super.kill();
				var h:Key = new Key();
				h.x = x;
				h.y = y;
				FP.world.add(h);
			
		}
		
		override public function update():void
		{
			
			if (GV.gamePaused) return;
			
			
			if (!GV.turnedevil) invincableTimer = 10;
			
			var heroDist:Number = FP.distance(x, y, GV.hero.x, GV.hero.y);
			movement.x = 0;
			movement.y = 0;
			
			
			if (state == ActorState.IDLE) {
				/*
				if (heroDist < 200) {
					if (GV.hero.x < x - 15) movement.x = -1;
					if (GV.hero.x > x + 15) movement.x = 1;
					if (GV.hero.y < y - 15) movement.y = -1;
					if (GV.hero.y > y + 15) movement.y = 1;
				}
				
				if (heroDist < 32) {
					GV.hero.hit(this, 1);
					state = ActorState.ATTACKING;
					attackTimer = 0.5;
					attackDelay = 0.8;
				}
				*/
			}
			
			super.update();
		}
		
		
	}

}