package Game.Mobs 
{
	import Game.Actor;
	import Game.ActorState;
	import Game.Items.Heart;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class Skeleton extends Actor 
	{
		
		public function Skeleton(_x:Number = 0, _y:Number = 0)
		{
			
			speed = 100;
			health = 3;
			x = _x;
			y = _y;
			
			sprites = new Spritemap(Assets.Skeleton, 64, 64);
			sprites.add("walkDown", [0, 4, 0, 8], 8, true);
			sprites.add("walkUp", [1, 5, 1, 9], 8, true);
			sprites.add("walkLeft", [2, 6, 2, 10], 8, true);
			sprites.add("walkRight", [3, 7, 3, 11], 8, true);
			
			sprites.add("standDown", [0]);
			sprites.add("standUp", [1]);
			sprites.add("standLeft", [2]);
			sprites.add("standRight", [3]);
			
			sprites.add("attackDown", [12, 16, 20], 6, false);
			sprites.add("attackUp", [13, 17, 21], 6, false);
			sprites.add("attackLeft", [14, 18, 22], 6, false);
			sprites.add("attackRight", [15, 19, 23], 6, false);
			
			sprites.centerOO();
			sprites.y = -32;
			
			graphic = sprites;
			type = "solid";
			setHitbox(20, 10, 10, 10);
		}
		
		override public function kill():void
		{
			super.kill();
			if (FP.rand(10) > 6) {
				var h:Heart = new Heart();
				h.x = x;
				h.y = y;
				FP.world.add(h);
			}
		}
		
		override public function update():void
		{
			
			if (GV.gamePaused) return;
			
			var heroDist:Number = FP.distance(x, y, GV.hero.x, GV.hero.y);
			movement.x = 0;
			movement.y = 0;
			
			if (state == ActorState.IDLE) {
				
				if (heroDist < 200) {
					if (GV.hero.x < x - 15) movement.x = -1;
					if (GV.hero.x > x + 15) movement.x = 1;
					if (GV.hero.y < y - 15) movement.y = -1;
					if (GV.hero.y > y + 15) movement.y = 1;
				}
				
				if (heroDist < 32) {
					GV.hero.hit(this, 1);
					state = ActorState.ATTACKING;
					attackTimer = 0.5;
					attackDelay = 0.8;
				}
			}
			
			super.update();
		}
		
	}

}