package Game.Mobs 
{
	import Game.Actor;
	import Game.ActorState;
	import Game.Items.Heart;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class Slime extends Actor 
	{
		
		public function Slime(_x:Number = 0, _y:Number = 0)
		{
			
			speed = 50;
			health = 2;
			x = _x;
			y = _y;
			
			sprites = new Spritemap(Assets.SLIME, 32, 32);
			sprites.add("walkDown", [0, 1], 8, true);
			sprites.add("walkUp", [0, 1], 8, true);
			sprites.add("walkLeft", [0, 1], 8, true);
			sprites.add("walkRight", [0, 1], 8, true);
			
			sprites.add("standDown", [0, 1], 8, true);
			sprites.add("standUp", [0, 1], 8, true);
			sprites.add("standLeft", [0, 1], 8, true);
			sprites.add("standRight", [0, 1], 8, true);
			
			sprites.add("attackDown", [2, 3], 8, true);
			sprites.add("attackUp", [2, 3], 8, true);
			sprites.add("attackLeft", [2, 3], 8, true);
			sprites.add("attackRight", [2, 3], 8, true);
			
			sprites.centerOO();
			sprites.y = -16;
			
			graphic = sprites;
			type = "solid";
			setHitbox(20, 10, 10, 10);
		}
		
		override public function kill():void
		{
			super.kill();
			GV.slimesKilled++;
			if (FP.rand(10) > 7) {
				var h:Heart = new Heart();
				h.x = x;
				h.y = y;
				FP.world.add(h);
			}
		}
		
		override public function update():void
		{
			
			if (GV.gamePaused) return;
			
			var heroDist:Number = FP.distance(x, y, GV.hero.x, GV.hero.y);
			movement.x = 0;
			movement.y = 0;
			
			if (state == ActorState.IDLE) {
				
				if (heroDist < 200) {
					if (GV.hero.x < x - 15) movement.x = -1;
					if (GV.hero.x > x + 15) movement.x = 1;
					if (GV.hero.y < y - 15) movement.y = -1;
					if (GV.hero.y > y + 15) movement.y = 1;
				}
				
				if (heroDist < 32) {
					GV.hero.hit(this, 1);
					state = ActorState.ATTACKING;
					attackTimer = 0.5;
					attackDelay = 0.8;
				}
			}
			
			super.update();
		}
		
	}

}