package Game 
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Emitter;
	import net.flashpunk.utils.Ease;
	
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class ParticleController extends Entity 
	{
		
		public var emitter:Emitter = new Emitter(Assets.Particles, 20, 20);
		
		public function ParticleController() 
		{
			emitter.newType("blood", [0]);
			emitter.setMotion("blood", 70, 100, 0.5, 40, 50, 0.5, Ease.expoOut);
			emitter.setGravity("blood", 2, 2);
			
			emitter.newType("death", [1]);
			emitter.setMotion("death", 60, 50, 1, 60, 40, 1, Ease.expoOut);
			emitter.setGravity("death", 0.4, 1);
			emitter.setAlpha("death", 1, 0.5);
			
			graphic = emitter;
		}
		
		public function emitDeath(_x:Number, _y:Number, movement:Point):void
		{
			for (var i:int = 0; i < 20; i++) {
			emitter.emit("death", _x - 10 + FP.rand(20), _y - 10 + FP.rand(20));
			}
		}
		
		
		public function emitBlood(_x:Number, _y:Number, movement:Point):void
		{
			emitter.emit("blood", _x, _y);
			emitter.emit("blood", _x + (5 * movement.x), _y + (5 * movement.y));
			emitter.emit("blood", _x + (10 * movement.x), _y + (10 * movement.y));
			emitter.emit("blood", _x + (15 * movement.x), _y + (15 * movement.y));
			emitter.emit("blood", _x + (20 * movement.x), _y + (20 * movement.y));
			emitter.emit("blood", _x + (25 * movement.x), _y + (25 * movement.y));
			emitter.emit("blood", _x + (30 * movement.x), _y + (30 * movement.y));
		}
		
	}

}