package Game 
{
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	/**
	 * ...
	 * @author Andy Brown
	 */
	public class Player extends Actor 
	{
		
		
		public var maxhealth:int = 5;
		private static var attacksfx:Sfx = new Sfx(Assets.Whoosh);
		public function Player() 
		{
			health = maxhealth;
			sprites = new Spritemap(Assets.PLAYER, 64, 64);
			sprites.add("walkDown", [0, 4, 0, 8], 8, true);
			sprites.add("walkUp", [1, 5, 1, 9], 8, true);
			sprites.add("walkLeft", [2, 6, 2, 10], 8, true);
			sprites.add("walkRight", [3, 7, 3, 11], 8, true);
			
			sprites.add("standDown", [0]);
			sprites.add("standUp", [1]);
			sprites.add("standLeft", [2]);
			sprites.add("standRight", [3]);
			
			sprites.add("attackDown", [12, 16, 20], 6, false);
			sprites.add("attackUp", [13, 17, 21], 6, false);
			sprites.add("attackLeft", [14, 18, 22], 6, false);
			sprites.add("attackRight", [15, 19, 23], 6, false);
			
			type = "solid";
			
			sprites.centerOO();
			sprites.y = -32;
			graphic = sprites;
			setHitbox(24, 24, 12, 20);
		}
		
		override public function added():void
		{
			super.added();
			GV.gui.updateHealth();
			
			
			FP.world.camera.x = x - FP.halfWidth;
			FP.world.camera.y = y - FP.halfHeight;
			if (FP.world.camera.x < 0) FP.world.camera.x = 0;
			if (FP.world.camera.x > GV.layer1.width - FP.width) FP.world.camera.x = GV.layer1.width - FP.width;
			if (FP.world.camera.y < 0) FP.world.camera.y = 0;
			if (FP.world.camera.y > GV.layer1.height - FP.height) FP.world.camera.y = GV.layer1.height - FP.height;
		}
		
		override public function kill():void
		{
			super.kill();
			health = 5;
			FP.world = new GameWorld();
			
		}
		
		override public function update():void
		{
			if (GV.gamePaused) return;
			
			movement.x = 0;
			movement.y = 0;
			if (Input.check("left")) movement.x += -1;
			if (Input.check("right")) movement.x += 1;
			if (Input.check("up")) movement.y += -1;
			if (Input.check("down")) movement.y += 1;
			
			if (Input.pressed("mute")) {
				if (FP.volume == 1) { FP.volume = 0; } else {
					FP.volume = 1;
				}
			}
			
			if (Input.pressed("menu")) FP.console.enable();
			
			
			if (Input.pressed("action") && state == ActorState.IDLE && attackDelay <= 0) {
				
				attacksfx.play();
				
				attackTimer = 0.5;
				attackDelay = 0.7;
				state = ActorState.ATTACKING;
			}
			
			super.update();
			
			FP.world.camera.x = x - FP.halfWidth;
			FP.world.camera.y = y - FP.halfHeight;
			if (FP.world.camera.x < 0) FP.world.camera.x = 0;
			if (FP.world.camera.x > GV.layer1.width - FP.width) FP.world.camera.x = GV.layer1.width - FP.width;
			if (FP.world.camera.y < 0) FP.world.camera.y = 0;
			if (FP.world.camera.y > GV.layer1.height - FP.height) FP.world.camera.y = GV.layer1.height - FP.height;
			
			if (state == ActorState.ATTACKING) {
				var attacked:Array = new Array;
				if (direction == GC.DOWN) FP.world.collideRectInto("solid", x - 20, y, 30, 30, attacked);
				if (direction == GC.UP) FP.world.collideRectInto("solid", x - 20 , y - 50, 30, 30, attacked);
				if (direction == GC.RIGHT) FP.world.collideRectInto("solid", x, y - 30, 30, 40, attacked);
				if (direction == GC.LEFT) FP.world.collideRectInto("solid", x - 30, y - 30, 30, 40, attacked);
				
				for each(var e:Entity in attacked) {
					var a:Actor = e as Actor;
					if(a != null) {
						if (a != this) {
							a.hit(this);
						}
					}
				}
			}
		}
		
	}

}